###############################################################################
# CP_DoCreateCategory.pl                                                      #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub DoCreateCategory {

# =========================================================================== #
# Verify Variables

  # checking missing fields
  if ($UB::QUERY{'FORM_TITLE'} eq "") { &Error("You forgot to fill the \"Title\" field.") };

  # checking length of fields
  if (length($UB::QUERY{'FORM_TITLE'}) > 128) {
    &Error("The \"Title\" field cannot more than 128 characters.");
  }

  if (length($UB::QUERY{'FORM_DESCRIPTION'}) > 512) {
    &Error("The \"Description\" field cannot more than 512 characters.");
  }

# =========================================================================== #
# Assign Variables
  my %FORM;

  $FORM{'TITLE'}       = $UB::QUERY{'FORM_TITLE'};
  $FORM{'TITLE'}       = &Standard::EncodeHTML($FORM{'TITLE'});

  $FORM{'DESCRIPTION'} = $UB::QUERY{'FORM_DESCRIPTION'};
  $FORM{'DESCRIPTION'} = &Standard::EncodeHTML($FORM{'DESCRIPTION'});

  ($FORM{'TITLE'}, $FORM{'DESCRIPTION'}) = &Standard::WordFilter($FORM{'TITLE'}, $FORM{'DESCRIPTION'});

# =========================================================================== #
# Add Category to Database

  (
    my $ID = &DB::Insert (
      TABLE  => "Categories",
      VALUES => \%FORM
    )
  ) || &HTML::Error("Internal Database Error", $DB::Error);

  &Standard::lock("file.lock") if ($SYSTEM::FLOCK == 1);

  chmod (0777, $SYSTEM::DB_PATH."/Categories");

  if ( # checking is it allow everyone to read this category
    ($UB::QUERY{'FORM_LEVEL_00'} eq "1"  ) ||
    ($UB::QUERY{'FORM_LEVEL_00'} eq "on" ) ||
    ($UB::QUERY{'FORM_LEVEL_00'} eq "y"  ) ||
    ($UB::QUERY{'FORM_LEVEL_00'} eq "yes")
  ) {
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-00.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-30.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-50.dat");
      print DATA "*";
    close (DATA);
  } else {
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-00.dat");
    close (DATA);

    if ( # checking the normal level has the permission to read this category
      ($UB::QUERY{'FORM_LEVEL_30'} eq "1"  ) ||
      ($UB::QUERY{'FORM_LEVEL_30'} eq "on" ) ||
      ($UB::QUERY{'FORM_LEVEL_30'} eq "y"  ) ||
      ($UB::QUERY{'FORM_LEVEL_30'} eq "yes")
    ) {
      my @Input = $UB::CGI->param('FORM_GROUP_30');
      # checking the member groups of this normal level have the permission to read this category
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-30.dat");
        if ($#Input != -1) {
          if ($Input[0] eq "*") {
            print DATA "*";
          } else {
            print DATA join ( "\n", @Input );
          }
        }
      close (DATA);
    } else {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-30.dat");
      close (DATA);
    }

    if ( # checking the premium level has the permission to read this category
      ($UB::QUERY{'FORM_LEVEL_50'} eq "1"  ) ||
      ($UB::QUERY{'FORM_LEVEL_50'} eq "on" ) ||
      ($UB::QUERY{'FORM_LEVEL_50'} eq "y"  ) ||
      ($UB::QUERY{'FORM_LEVEL_50'} eq "yes")
    ) {
      my @Input = $UB::CGI->param('FORM_GROUP_50');
      # checking the member groups of this premium level have the permission to read this category
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-50.dat");
        if ($#Input != -1) {
          if ($Input[0] eq "*") {
            print DATA "*";
          } else {
            print DATA join ( "\n", @Input );
          }
        }
      close (DATA);
    } else {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/Categories/$ID-LEVEL-50.dat");
      close (DATA);
    }
  }

  &Standard::unLock("file.lock") if ($SYSTEM::FLOCK == 1);

  &Success(\%FORM);
}

###############################################################################
# Error function
# - function of printing error message of creating category
sub Error {
  my ($message) = @_;

  require "$UB::SOURCES_PATH/CP_CreateCategory.pl";
  &Source::CreateCategory($message);

  exit;
}

###############################################################################
# Success function
# - function of printing success message of creating category
sub Success {
  my ($FORM) = @_;

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / Categories Management / Create a new category
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>The category has been created, following is the information of this category.</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            &nbsp;&nbsp;General Information
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td width="100" valign="top" nowrap>Title</td>
                      <td width="100%">$FORM->{'TITLE'}</td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>Description</td>
                      <td width="100%">$FORM->{'DESCRIPTION'}</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</body>
</html>
HTML

  exit;
}

###############################################################################
1; # end of CP_DoCreateCategory.pl file
###############################################################################