###############################################################################
# CP_DoMoveAccounts.pl                                                        #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub DoMoveAccounts {

  my ($Accounts, $AccountsIndex) = &DB::Query (
    TABLE   => "Accounts"      ,
    COLUMNS => ["USERNAME", "GROUP"]
  );

  (
    my ($Group) = &DB::BinarySelect (
      TABLE   => "Groups",
      COLUMNS => ["ID", "TITLE"],
      KEY     => $UB::QUERY{'FORM_GROUP'}
    )
  ) || &HTML::Error ("Internal Database Error", $DB::Error);

# =========================================================================== #
# Move members accounts from Database

  my $FORM_GROUP = $UB::QUERY{'FORM_GROUP'};

  my $MovedMembers = 0;
  foreach my $Username ( split (/,/, $UB::QUERY{'UIDS'}) ) {
    if ( ($AccountsIndex->{$Username}) && ($Accounts->[ $AccountsIndex->{$Username} ]{'GROUP'} ne $Group->{'ID'}) ) {
      my $Account = $Accounts->[ $AccountsIndex->{$Username} ];
      (
        &DB::Update (
          TABLE  => "Accounts",
          VALUES => {
            GROUP      => $Group->{'ID'},
            GROUP_TEXT => $Group->{'TITLE'}
          },
          KEY    => $Username
        )
      ) || &HTML::Error("Internal Database Error", $DB::Error);

      (
        &DB::Update (
          TABLE   => "Groups",
          VALUES  => {
            TOTAL_MEMBERS => "--\${TOTAL_MEMBERS}"
          },
          KEY     => $Account->{'GROUP'}
        )
      ) || &HTML::Error("Internal Database Error", $DB::Error);

      $MovedMembers++;
    }
  }

  (
    &DB::Update (
      TABLE   => "Groups",
      VALUES  => {
        TOTAL_MEMBERS => "\${TOTAL_MEMBERS} + $MovedMembers"
      },
      KEY     => $FORM_GROUP
    )
  ) || &HTML::Error("Internal Database Error", $DB::Error);

  &Success();
}

###############################################################################
# Success function
# - function of printing success message of moving members accounts
sub Success {
  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / Members Accounts Management / Move member(s) accounts
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>Those members accounts have been moved.</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</body>
</html>
HTML

  exit;
}

###############################################################################
1; # end of CP_DoMoveAccounts.pl file
###############################################################################