###############################################################################
# CP_DoRemoveCategories.pl                                                    #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub DoRemoveCategories {

  (
    my ($Categories) = &DB::Query (
      TABLE   => "Categories" ,
      COLUMNS => ["ID", "POSITION"],
      SORT    => "POSITION"   ,
      BY      => "A-Z"
    )
  ) || &HTML::Error("Categories Management / Remove category", "No category available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateCategory\" target=\"UBBODY\">create a new category</a> first!");

# =========================================================================== #
# Remove Categories from Database

  my @Index;
  for (my $i = 0; $i <= $#{$Categories}; $i++) {
    if ($UB::QUERY{"CID_".$Categories->[$i]{'ID'}}) {
      push (@Index , $Categories->[$i]{'ID'});
      unlink ("$SYSTEM::DB_PATH/Categories/".$Categories->[$i]{'ID'}."-LEVEL-00.dat");
      unlink ("$SYSTEM::DB_PATH/Categories/".$Categories->[$i]{'ID'}."-LEVEL-30.dat");
      unlink ("$SYSTEM::DB_PATH/Categories/".$Categories->[$i]{'ID'}."-LEVEL-50.dat");
    }
  }

  (
    &DB::Delete (
      TABLE  => "Categories",
      KEYS   => \@Index
    )
  ) || &HTML::Error("Internal Database Error", $DB::Error);

  &Success();
}

###############################################################################
# Success function
# - function of printing success message of removing categories
sub Success {
  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / Categories Management / Remove category
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>Those categories have been removed.</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</body>
</html>
HTML

  exit;
}

###############################################################################
1; # end of CP_DoRemoveCategories.pl file
###############################################################################