###############################################################################
# CP_ListBoards.pl                                                            #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub ListBoards {

  my ($Action, $Address, $Description, $Script, $Form);
  if ($UB::QUERY{'For'} eq "ModifyBoard") {
    $Action      = "ModifyBoard";
    $Address     = "Modify board";
    $Description = "Please select a board to modify.";
    $Script      = "";
    $Form        = "";
  } elsif ($UB::QUERY{'For'} eq "ReorderBoards") {
    $Action      = "DoReorderBoards";
    $Address     = "Reorder boards";
    $Description = "Please reorder the boards by changing the numbers.";
    $Script      = "";
    $Form        = "";
  } elsif ($UB::QUERY{'For'} eq "RemoveBoards") {
    $Action      = "DoRemoveBoards";
    $Address     = "Remove boards";
    $Description = "Please select the board(s) to remove.";
    $Script      = "<SCRIPT LANGUAGE=\"JavaScript\"> function Confirm () { return confirm(\"Are you sure to remove these boards?\"); } </SCRIPT>";
    $Form       = " onSubmit = \"return Confirm();\"";
  }

  (
    my ($Categories, $CategoriesIndex) = &DB::Query (
      TABLE   => "Categories" ,
      SORT    => "POSITION"   ,
      BY      => "A-Z"
    )
  ) || &HTML::Error("Boards Management / $Address", "No category available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateCategory\" target=\"UBBODY\">create a new category</a> first!");

  (
    my ($Boards) = &DB::Query (
      TABLE   => "Boards"   ,
      SORT    => "POSITION" ,
      BY      => "A-Z"
    )
  ) || &HTML::Error("Boards Management / $Address", "No board available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateBoard\" target=\"UBBODY\">create a new board</a> first!");

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
$Script
<form action="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT" method="post" name="form"$Form>
<input type="hidden" name="action" value="$Action">
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / Boards Management /  $Address
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>
                      $Description
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            <table width="100%" border="1" cellspacing="0" cellpadding="2" bordercolordark="White" bordercolorlight="Gray">
              <tr height=24>
                <td nowrap>&nbsp;</td>
                <td width="100%">&nbsp;Title&nbsp;</td>
                <td nowrap>&nbsp;Major moderator&nbsp;</td>
                <td nowrap>&nbsp;Total topic&nbsp;</td>
                <td nowrap>&nbsp;Total post&nbsp;</td>
                <td nowrap>&nbsp;Last post&nbsp;</td>
                <td nowrap>&nbsp;Status&nbsp;</td>
              </tr>
HTML
  for (my $c = 0; $c <= $#{$Categories}; $c++) {
    my @Order;
    my $Order = 1;
    if ($UB::QUERY{'For'} eq "ReorderBoards") {
      for (my $o = 1; $o <= $Categories->[$c]{'TOTAL_BOARDS'}; $o++) {
        push (@Order,
          {
            KEY   => sprintf ("%d\.%0.3d", $c, $o),
            VALUE => $o
          }
        );
      }
    }
    print<<HTML;
              <tr bgcolor="Silver" height=24>
                <td colspan="7">&nbsp;$Categories->[$c]{'TITLE'}&nbsp;</td>
              </tr>
HTML
    for (my $i = 0; $i <= $#{$Boards}; $i++) {
      next if ($Boards->[$i]{'CATEGORY'} ne $Categories->[$c]{'ID'});
      my $Board = $Boards->[$i];
      my $Form;
      $Board = &Standard::UnReturn($Board);
      my $order = sprintf ("%d\.%0.3d", $c, $Order);
      if ($UB::QUERY{'For'} eq "ModifyBoard") {
        $Form = &HTML::Radio (
          NAME    => "BID"         ,
          VALUE   => $Board->{'ID'},
          CHECKED => $UB::QUERY{'BID'} || ""
        );
      } elsif ($UB::QUERY{'For'} eq "ReorderBoards") {
        $Form = &HTML::Select (
          NAME     => "BID_".$Board->{'ID'},
          VALUE    => \@Order              ,
          SELECTED => ($UB::QUERY{"BID_".$Board->{'ID'}}) ? [$UB::QUERY{"BID_".$Board->{'ID'}}] : [$order]
        );
      } elsif ($UB::QUERY{'For'} eq "RemoveBoards") {
        $Form = &HTML::Checkbox (
          NAME    => "BID_".$Board->{'ID'},
          VALUE   => "1"                  ,
          CHECKED => $UB::QUERY{"BID_".$Board->{'ID'}} || ""
        );
      }
      $Order++;
      print<<HTML;
              <tr bgcolor="White">
                <td bgcolor="Silver" nowrap>$Form</td>
                <td width="100%">&nbsp;$Board->{'TITLE'}&nbsp;</td>
                <td nowrap>&nbsp;${ \($Board->{'MAJOR_MODERATOR_NICKNAME'} || "n/a") }&nbsp;</td>
                <td nowrap align="center">&nbsp;$Board->{'TOTAL_TOPICS'}&nbsp;</td>
                <td nowrap align="center">&nbsp;$Board->{'TOTAL_POSTS'}&nbsp;</td>
                <td nowrap>&nbsp;${ \(($Board->{'LAST_POST_DATE'}) ? $Board->{'LAST_POST_DATE'}." ".$Board->{'LAST_POST_TIME'} : "n/a") }&nbsp;</td>
                <td nowrap align="center">&nbsp;$Board->{'STATUS'}&nbsp;</td>
              </tr>
HTML
    }
  }

print<<HTML;
            </table>
          </td>
        </tr>
      </table>
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
        <tr>
          <td align="right"><input type="submit" value="Next &gt;">&nbsp;&nbsp;<input type="Reset" value="Cancel"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
HTML
}

###############################################################################
1; # end of CP_ListBoards.pl file
###############################################################################