###############################################################################
# CP_ListCategories.pl                                                        #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub ListCategories {

  my ($Action, $Address, $Description, $Script, $Form);
  if ($UB::QUERY{'For'} eq "ModifyCategory") {
    $Action      = "ModifyCategory";
    $Address     = "Modify category";
    $Description = "Please select a category to modify.";
    $Script      = "";
    $Form        = "";
  } elsif ($UB::QUERY{'For'} eq "ReorderCategories") {
    $Action      = "DoReorderCategories";
    $Address     = "Reorder categories";
    $Description = "Please reorder the categories by changing the numbers.";
    $Script      = "";
    $Form        = "";
  } elsif ($UB::QUERY{'For'} eq "RemoveCategories") {
    $Action      = "DoRemoveCategories";
    $Address     = "Remove categories";
    $Description = "Please select which categories that you want to remove.";
    $Script      = "<SCRIPT LANGUAGE=\"JavaScript\"> function Confirm () { return confirm(\"Are you sure to remove these categories?\"); } </SCRIPT>";
    $Form       = " onSubmit = \"return Confirm();\"";
  }

  (
    my ($Categories) = &DB::Query (
      TABLE   => "Categories" ,
      SORT    => "POSITION"   ,
      BY      => "A-Z"
    )
  ) || &HTML::Error("Categories Management / $Address", "No category available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateCategory\" target=\"UBBODY\">create a new category</a> first!");

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
$Script
<form action="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT" method="post" name="form"$Form>
<input type="hidden" name="action" value="$Action">
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / Categories Management /  $Address
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>
                      $Description
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            <table width="100%" border="1" cellspacing="0" cellpadding="2" bordercolordark="White" bordercolorlight="Gray">
              <tr height=24>
                <td nowrap>&nbsp;</td>
                <td width="100%">&nbsp;Title&nbsp;</td>
                <td nowrap>&nbsp;Total boards&nbsp;</td>
                <td nowrap>&nbsp;Total topic&nbsp;</td>
                <td nowrap>&nbsp;Total post&nbsp;</td>
                <td nowrap>&nbsp;Last updated&nbsp;</td>
              </tr>
HTML
  my @Order;
  my $Order = 1;
  if ($UB::QUERY{'For'} eq "ReorderCategories") {
    for (my $o = 1; $o <= $#{$Categories} + 1; $o++) {
      push (@Order,
        {
          KEY   => $o,
          VALUE => $o
        }
      );
    }
  }
  for (my $i = 0; $i <= $#{$Categories}; $i++) {
    my $Category = $Categories->[$i];
    my $Form;
    $Category = &Standard::UnReturn($Category);
    if ($UB::QUERY{'For'} eq "ModifyCategory") {
      $Form = &HTML::Radio (
        NAME    => "CID"            ,
        VALUE   => $Category->{'ID'},
        CHECKED => $UB::QUERY{'CID'} || ""
      );
    } elsif ($UB::QUERY{'For'} eq "ReorderCategories") {
      $Form = &HTML::Select (
          NAME     => "CID_".$Category->{'ID'},
          VALUE    => \@Order                 ,
          SELECTED => ($UB::QUERY{"CID_".$Category->{'ID'}}) ? [$UB::QUERY{"CID_".$Category->{'ID'}}] : [$Order]
        );
    } elsif ($UB::QUERY{'For'} eq "RemoveCategories") {
      next if ($Category->{'TOTAL_BOARDS'} > 0);
      $Form = &HTML::Checkbox (
        NAME    => "CID_".$Category->{'ID'},
        VALUE   => "1"                     ,
        CHECKED => $UB::QUERY{"CID_".$Category->{'ID'}} || ""
      );
    }
    $Order++;
    print<<HTML;
              <tr bgcolor="White">
                <td bgcolor="Silver" nowrap>$Form</td>
                <td width="100%" valign="middle">&nbsp;$Category->{'TITLE'}&nbsp;</td>
                <td nowrap align="center">&nbsp;$Category->{'TOTAL_BOARDS'}&nbsp;</td>
                <td nowrap align="center">&nbsp;$Category->{'TOTAL_POSTS'}&nbsp;</td>
                <td nowrap align="center">&nbsp;$Category->{'TOTAL_TOPICS'}&nbsp;</td>
                <td nowrap>&nbsp;${ \(($Category->{'LAST_UPDATE_DATE'}) ? $Category->{'LAST_UPDATE_DATE'}." ".$Category->{'LAST_UPDATE_TIME'} : "n/a") }&nbsp;</td>
              </tr>
HTML
  }
print<<HTML;
            </table>
          </td>
        </tr>
      </table>
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
        <tr>
          <td align="right"><input type="submit" value="Next &gt;">&nbsp;&nbsp;<input type="Reset" value="Cancel"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
HTML
}

###############################################################################
1; # end of CP_ListCategories.pl file
###############################################################################