###############################################################################
# CP_ManageMessages.pl                                                        #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

sub ManageMessages {
  my ($ERROR) = @_;

  ( # querying data from categories table
    my ($Categories, $CateogriesIndex) = &DB::Query (
      TABLE   => "Categories",
      COLUMNS => ["ID", "TITLE"]
    )
  ) || &HTML::Error("Boards Management / Messages Management / Manage messages", "No category available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateCategory\" target=\"UBBODY\">create a new category</a> first!");

  ( # querying data from categories table
    my ($DB) = &DB::Query (
      TABLE   => "Boards",
      COLUMNS => ["ID", "TITLE", "CATEGORY", "POSITION"],
      SORT    => "POSITION",
      BY      => "A-Z"
    )
  ) || &HTML::Error("Boards Management / Messages Management / Manage messages", "No board available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateBoard\" target=\"UBBODY\">create a new board</a> first!");

  my $Boards;
  for (my $i = 0; $i <= $#{ $DB }; $i++) {
    push (
      @{ $Boards },
      {
        KEY   => $DB->[$i]{'ID'},
        VALUE => $Categories->[ $CateogriesIndex->{ $DB->[$i]{'CATEGORY'} } ]{'TITLE'}." / ".$DB->[$i]{'TITLE'}
      }
    );
  }

  my %FORM;
  $FORM{'FORM_BOARDS'} = &HTML::Select (
    NAME      => "FORM_BOARDS",
    VALUE     => $Boards      ,
    MULTIPLE  => 1            ,
    SIZE      => 3            ,
    SELECTED  => [$UB::CGI->param('FORM_BOARDS')],
    EXTRA     => "style=\"width:100%\""
  );

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<form action="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT" method="post">
<input type="hidden" name="action" value="ListMessages">
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / Messages Management / Manage messages
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>
                      Fill out as many fields as possible to narrow search results.
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            &nbsp;&nbsp;Search
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td width="100" valign="top" nowrap>Keyword</td>
                      <td width="100%">
                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                          <tr>
                            <td nowrap><input type="text" name="FORM_KEYWORD" value="" maxlength="256"></td>
                            <td nowrap>&nbsp;&nbsp;in&nbsp;&nbsp;</td>
                            <td width="100%"><select name="FORM_METHOD" class="Select" style="width:100%">
                              <option value="SBU">subject, body, or username/nickname</option>
                              <option value="SB">subject, or body</option>
                              <option value="SU">subject, or username/nickname</option>
                              <option value="S">subject only</option>
                              <option value="B">body only</option>
                              <option value="U">username/nickname only</option>
                            </select></td>
                            <td nowrap>&nbsp;&nbsp;fields.</td>
                          </tr>
                        </table>
                      </td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="enter a word for searching any messages that included.\n\ntips:\na word begin with ^ mean start with this word.\n\na word end with \$ mean end with this word."></td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>Boards</td>
                      <td width="100%">$FORM{'FORM_BOARDS'}</td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="select which boards that you want to search in.\n\ntips:\nhold the [ctrl] key for multiple select."></td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>Date</td>
                      <td width="100%">
                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                          <tr>
                            <td nowrap><select name="FORM_DATE_BOOLEAN" class="Select"><option value="GT">more</option><option value="LT">less</option></select></td>
                            <td nowrap>&nbsp;&nbsp;than&nbsp;&nbsp;</td>
                            <td width="100%"><select name="FORM_DATE_DAYS" class="Select" style="width:100%">
                              <option value="*">any days</option>
                              <option value="1">1 day</option>
                              <option value="2">2 days</option>
                              <option value="3">3 days</option>
                              <option value="7">7 days</option>
                              <option value="14">14 days</option>
                              <option value="30">30 days</option>
                              <option value="45">45 days</option>
                              <option value="60">60 days</option>
                              <option value="90">90 days</option>
                              <option value="180">180 days</option>
                              <option value="365">365 days</option>
                            </select></td>
                          </tr>
                        </table>
                      </td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="searching any messages that before or after these days."></td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>Sort Order</td>
                      <td width="100%">
                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                          <tr>
                            <td nowrap>Sort&nbsp;&nbsp;</td>
                            <td nowrap><select name="FORM_SORT_FIELD" class="Select">
                              <option value="SUBJECT">subject</option>
                              <option value="NICKNAME">author</option>
                              <option value="POST_SECOND">post date</option>
                            </select></td>
                            <td nowrap>&nbsp;&nbsp;by&nbsp;&nbsp;</td>
                            <td width="100%"><select name="FORM_SORT_ORDER" class="Select" style="width:100%">
                              <option value="A-Z">ascending</option>
                              <option value="Z-A">descending</option>
                            </select></td>
                            <td nowrap>&nbsp;&nbsp;order.</td>
                          </tr>
                        </table>
                      </td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="choose a field that you want to sort the order."></td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>View Mode</td>
                      <td width="100%">
                        <table width="100%" border="0" cellspacing="0" cellpadding="2">
                          <tr>
                            <td width="100%">
                            <input type="Radio" name="FORM_VIEW" value="TopicOnly" checked class="Radio">List only the topic headlines.<br>
                            <input type="Radio" name="FORM_VIEW" value="All" class="Radio">List the topic headlines and their replies.<br>
                          </tr>
                        </table>
                      </td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="choose a way to display the results"></td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            &nbsp;&nbsp;Action
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td width="100%">
                      <input type="Radio" name="FORM_ACTION" value="ReadOnlyMessages" checked class="Radio">Close/Open message(s)<br>
                      <input type="Radio" name="FORM_ACTION" value="ModifyMessage" class="Radio">Modify message<br>
                      <input type="Radio" name="FORM_ACTION" value="MoveMessages" class="Radio">Move message(s)<br>
                      <input type="Radio" name="FORM_ACTION" value="RemoveMessages" class="Radio">Remove message(s)</td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="choose a action to manage the messages."></td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
        <tr>
          <td align="right"><input type="submit" value="Search">&nbsp;&nbsp;<input type="Reset" value="Cancel"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
HTML
}

###############################################################################
1; # end of CP_ManageMessages.pl file
###############################################################################