###############################################################################
# CP_Rebuild.pl                                                               #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub Rebuild {
  ( # querying data from categories table
    my ($Categories, $CateogriesIndex) = &DB::Query (
      TABLE   => "Categories",
      COLUMNS => ["ID", "TITLE"]
    )
  ) || &HTML::Error("Boards Management / UltraBoard Utilities / Rebuild data", "No category available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateCategory\" target=\"UBBODY\">create a new category</a> first!");

  ( # querying data from categories table
    my ($DB) = &DB::Query (
      TABLE   => "Boards",
      COLUMNS => ["ID", "TITLE", "CATEGORY", "POSITION"],
      SORT    => "POSITION",
      BY      => "A-Z"
    )
  ) || &HTML::Error("Boards Management / UltraBoard Utilities / Rebuild data", "No board available for you to choose yet.<br>Sorry, you have to <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateBoard\" target=\"UBBODY\">create a new board</a> first!");

  my $Boards;
  for (my $i = 0; $i <= $#{ $DB }; $i++) {
    push (
      @{ $Boards },
      {
        KEY   => $DB->[$i]{'ID'},
        VALUE => $Categories->[ $CateogriesIndex->{ $DB->[$i]{'CATEGORY'} } ]{'TITLE'}." / ".$DB->[$i]{'TITLE'}
      }
    );
  }

  my %FORM;
  $FORM{'FORM_BOARD'} = &HTML::Select (
    NAME      => "FORM_BOARD",
    VALUE     => $Boards      ,
    SELECTED  => [],
    EXTRA     => "style=\"width:100%\""
  );

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<script language="JavaScript">
  function Confirm () {
    return confirm("Are you sure to rebuild the UltraBoard 2000? It may take couple hours to rebuild!");
  }
</script>
<form action="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT" method="post" name="form" onSubmit="return Confirm()">
<input type="hidden" name="action" value="DoRebuild">
<input type="hidden" name="FORM" value="0">
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / UltraBoard Utilities / Rebuild data
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>
                      Ready to rebuild the UltraBoard 2000 database now?
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td nowrap><input type="radio" name="FORM_TYPE" value="DATABASE" checked></td>
                      <td width="100%">Rebuild all the database</td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="it will rebuild a the data from the database, but wouldn't rebuild all the topics."></td>
                    </tr>
                    <tr>
                      <td nowrap><input type="radio" name="FORM_TYPE" value="TOPICS"></td>
                      <td width="100%">Rebuild all the topic from</td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="it will rebuild all the topics from the board that you have selected."></td>
                    </tr>
                    <tr>
                      <td nowrap>&nbsp;</td>
                      <td width="100%">$FORM{'FORM_BOARD'}</td>
                      <td width="20" valign="top" nowrap>&nbsp;</td>
                    </tr>
                    <tr>
                      <td nowrap>&nbsp;</td>
                      <td width="100%">Rebuild
                      <select name="EVERY">
                        <option value="100">100</option>
                        <option value="200">200</option>
                        <option value="300">300</option>
                        <option value="400">400</option>
                        <option value="500">500</option>
                        <option value="600">600</option>
                        <option value="700">700</option>
                        <option value="800">800</option>
                        <option value="900">900</option>
                        <option value="1000">1000</option>
                      </select>
                      topics in every process
                      </td>
                      <td width="20" valign="top" nowrap>&nbsp;</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
        <tr>
          <td align="right"><input type="submit" value="Start Rebuild">&nbsp;&nbsp;<input type="Reset" value="Cancel"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
HTML
}

###############################################################################
1; # end of CP_Rebuild.pl file
###############################################################################