###############################################################################
# CP_Restore.pl                                                               #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub Restore {
  my @Select;
  opendir (DIR, $SYSTEM::BACKUP) || &HTML::Error("Internal Error", "Can't open the backup directory. $!\nPath: $SYSTEM::BACKUP");
    while ( defined (my $FILE = readdir (DIR)) ) {
      next if ($FILE =~ /^\.\.?$/);
      if (-d $SYSTEM::BACKUP."/".$FILE) {
        if ($FILE =~ /^UB2K\-(\w+)$/) {
          my $Epoch = $1;
          my $Date  = &Standard::ConvertEpochToDate ($Epoch);
          my $Time  = &Standard::ConvertEpochToTime ($Epoch);
          push (
            @Select,
            {
              KEY   => $Epoch,
              VALUE => $Date." ".$Time
            }
          );
        }
      }
    }
  closedir (DIR);

  @Select = reverse (@Select);

  my %FORM;
  $FORM{'FORM_TIME'}     = &HTML::Select (
    NAME      => "FORM_TIME"            ,
    VALUE     => \@Select               ,
    EXTRA     => "style=\"width:100%\""
  );

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<script language="JavaScript">
  function Confirm () {
    return confirm("Are you sure to restore the UltraBoard 2000 datebase? Please backup all the UltraBoard 2000 data first, because it will delete all your data, before restore the backup!!");
  }
</script>
<form action="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT" method="post" name="form" onSubmit="return Confirm()">
<input type="hidden" name="action" value="DoRestore">
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">Control Panel</a> / UltraBoard Utilities / Backup data
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>
                      Ready to restore the UltraBoard 2000 database now?
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td width="100" valign="top" nowrap>Backup</td>
                      <td width="100%">$FORM{'FORM_TIME'}</td>
                      <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="choose a which date of backup that you want to restore it."></td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
        <tr>
          <td align="right"><input type="submit" value="Start Restore">&nbsp;&nbsp;<input type="Reset" value="Cancel"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
HTML
}

###############################################################################
1; # end of CP_Restore.pl file
###############################################################################