###############################################################################
# SMTP.lib.pl                                                                 #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Mail;

use Socket;

sub Send {

# =========================================================================== #
# Verify Variables

  my %args = (
    TO          => "",
    FROM        => "$GENERAL::ULTRABOARD_NAME <$GENERAL::CONTACT_EMAIL>",
    REPLY       => "",
    CC          => "",
    BCC         => "",
    SUBJECT     => "",
    MESSAGE     => "",
    HEADER      => "Content-type: text/html; charset=\"iso-8859-1\"", # Content-type: text/plain; charset=\"iso-8859-1\"
    SMTP        => $SYSTEM::SMTP_PATH,
    SENDMAIL    => $SYSTEM::SENDMAIL_PATH,
    @_
  );

  return unless ($args{'TO'});

  $args{'TO'}       =~ s/[ \t]+/ /g;

  $args{'CC'}       =~ s/[ \t]+/ /g;
  $args{'BCC'}      =~ s/[ \t]+/ /g;

  $args{'TO'}       =~ s/,,/,/g;
  $args{'CC'}       =~ s/,,/,/g;
  $args{'BCC'}      =~ s/,,/,/g;

  my $FromAddress   = $args{'FROM'};
     $FromAddress   =~ s/.*<([^\s]*?)>/$1/;

  my $ReplyAddress  = $args{'REPLY'};
     $ReplyAddress  =~ s/.*<([^\s]*?)>/$1/;
     $ReplyAddress  =~ s/^([^\s]+).*/$1/;

  my ($CRLF)        = "\n"; #"\015\012";

# =========================================================================== #
# Connecting the SMTP Server

  my ($Protocol)    = (getprotobyname('tcp')        )[2];
  my ($Port)        = (getservbyname ('smtp', 'tcp'))[2];

  my ($SMTPAddress) = ($args{'SMTP'} =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)
                      ? pack('C4', $1, $2, $3, $4) : (gethostbyname($args{'SMTP'}))[4];

  my ($LocalHost)   = (gethostbyname('localhost'))[0] || "localhost";

  unless (defined($SMTPAddress)) {
    &UB::CGIError("The SMTP server $args{'SMTP'} was not found. $!", "$args{'SMTP'}");
  }

  unless (socket(SMTP, AF_INET, SOCK_STREAM, $Protocol)) {
    &UB::CGIError("Error on socket() function. $!", "$args{'SMTP'}");
  }

  unless (connect(SMTP, pack('Sna4x8', AF_INET, $Port, $SMTPAddress))) {
    &UB::CGIError("Error on connect() function. $!", "$args{'SMTP'}");
  }

  my ($OldFileHandle) = select(SMTP);
  $| = 1;
  select($OldFileHandle);

  $_ = <SMTP>;
  if ((/^[45]/) || (!$_)) {
    close (SMTP);
    &UB::CGIError("Service not available. $_", "$args{'SMTP'}");
  }

  print SMTP "helo $LocalHost$CRLF";
  $_ = <SMTP>;
  if ((/^[45]/) || (!$_)) {
    close (SMTP);
    &UB::CGIError("Unspecified communication error. $_", "$args{'SMTP'}");
  }

  if ($args{'FROM'} =~ /<(.*)>/) {
    print SMTP "mail from: <$1>$CRLF";
  } else {
    print SMTP "mail from: <$args{'FROM'}>$CRLF";
  }
  $_ = <SMTP>;
  if ((/^[45]/) || (!$_)) {
    close (SMTP);
    &UB::CGIError("Unspecified communication error. $_", "$args{'SMTP'}");
  }

  foreach my $To (split(/, */, $args{'TO'}), split(/, */, $args{'CC'}), split(/, */, $args{'BCC'})) {
    if ($To =~ /<(.*)>/) {
      print SMTP "rcpt to: $1$CRLF";
    } else {
      print SMTP "rcpt to: <$To>$CRLF";
    }

    $_ = <SMTP>;
    if ((/^[45]/) || (!$_)) {
      close (SMTP);
      return;
      #&UB::CGIError("Couldn't send email to \"$To\". $_", "$args{'SMTP'}");
    }
  }

  print SMTP "data$CRLF";
  $_ = <SMTP>;
  if ((/^[45]/) || (!$_)) {
    close (SMTP);
    &UB::CGIError("Unspecified communication error. $_", "$args{'SMTP'}");
  }

# =========================================================================== #
# Sending Message

  print SMTP "To: "         . $args{'TO'}   . $CRLF;
  print SMTP "From: "       . $args{'FROM'} . $CRLF;
  print SMTP "Reply-to: "   . $ReplyAddress . $CRLF if ($ReplyAddress  );
  print SMTP "Bcc: "        . $args{'BCC'}  . $CRLF if ($args{'BCC'}   );
  print SMTP "Cc: "         . $args{'CC'}   . $CRLF if ($args{'CC'}    );
  print SMTP $args{'HEADER'}                . $CRLF if ($args{'HEADER'});

  print SMTP "X-Mailer: UltraBoard 2000"                . $CRLF;
  print SMTP "X-Mailer-Info: http://www.UltraBoard.org/". $CRLF;

  print SMTP "Subject: "  . $args{'SUBJECT'}. $CRLF     . $CRLF;
  print SMTP                $args{'MESSAGE'}. $CRLF. ".". $CRLF;

  $_ = <SMTP>;
  if ((/^[45]/) || (!$_)) {
    close (SMTP);
    &UB::CGIError("Transmission of message failed. $_", "$args{'SMTP'}");
  }

  print SMTP "quit"                         , $CRLF;
  $_ = <SMTP>;

  close (SMTP);

# =========================================================================== #
# Track Down Current Send Mail Infomation

  if ($SYSTEM::LOGS) {
    &Standard::lock("sendmail.lock") unless ($SYSTEM::FLOCK == 1);

    (-e "$SYSTEM::LOGS_PATH/sendmail.log") ?
    (&Standard::FileOpen(*LOG, "a", "$SYSTEM::LOGS_PATH/sendmail.log")) :
    (&Standard::FileOpen(*LOG, "w", "$SYSTEM::LOGS_PATH/sendmail.log"));
      print LOG "$ENV{'REMOTE_ADDR'}|$args{'TO'}|$args{'FROM'}|$args{'BCC'}|$args{'CC'}|$ReplyAddress|$args{'SUBJECT'}\n";
    close (LOG);

    &Standard::unLock("sendmail.lock") unless ($SYSTEM::FLOCK == 1);
  }

  return 1;
}

###############################################################################
1; # end of SMTP.lib.pl file
###############################################################################