###############################################################################
# UB_DoMoveTopic.pl                                                           #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub DoMoveTopic {

# =========================================================================== #
# Checking Permission

  my ($Board) = &DB::BinarySelect (
    TABLE   => "Boards" ,
    COLUMNS => ["ID", "TITLE", "MAJOR_MODERATOR", "MINOR_MODERATORS", "STATUS", "CATEGORY"],                          ,
    KEY     => $UB::QUERY{'BID'}
  ) || &HTML::Error(MESSAGE => $DB::Error);

  my $Moderators = "\|".join ("\|", ($Board->{'MAJOR_MODERATOR'}, split (/\s*,\s*/, $Board->{'MINOR_MODERATORS'})))."\|";
     $Moderators =~ s/\|\s*\|/\|/g;

  my $isAdmin = 0;
  if ($UB::MEMBER{'LOGIN'} == 1) {
    if (($UB::MEMBER{'LEVEL'} eq "70") || ($UB::MEMBER{'LEVEL'} eq "100")) {
      $isAdmin = 1;
    } else {
      if ("$Moderators" !~ /\|$UB::MEMBER{'USERNAME'}\|/) {
        &HTML::Error(CODE => "WRONG_MODERATOR");
      }
    }
  } else {
    &Login();
  }

  my $BID    = $UB::QUERY{'BID'};
  my $TID    = $UB::QUERY{'TID'};
  my $TO_BID = $UB::QUERY{'ToBID'};

  &Standard::Require("Move.lib.pl", "$UB::LIBRARIES_PATH/Move.lib.pl");

  &Standard::PrintHTMLHeader();

  my $Return = &Move::Topic (
    FROM_BOARD => $BID   ,
    FROM_TOPIC => $TID   ,
    TO_BOARD   => $TO_BID,
    DETAIL     =>  0     ,
  );

  if ($Return < 1) {
    &HTML::Error(MESSAGE => $DB::Error);
  }

  my %FORM = (
    "BOARD.ID"          => $Board->{'ID'}                 || "",
    "BOARD.TITLE"       => $Board->{'TITLE'}              || "",

    "TOPIC.ID"          => $TID                           || "",

    "TO_BOARD.ID"       => $TO_BID                        || "",

    "TO_TOPIC.ID"       => $Return                        || "",

    &Standard::ExtraVariables()
  );

  &Success(\%FORM);
}

###############################################################################
# Success function
# - function of printing success message of closing topic
sub Success {
  my ($FORM) = @_;

  &Standard::Require("UB_Move_Topic_Success.src", "$UB::INTERFACES_PATH/$SYSTEM::DEFAULT_THEME/UB_Move_Topic_Success.src");

  print &Move_Topic_Success::Parse($FORM);
  exit;
}

sub Login {
  print "Location: $SYSTEM::UB_URL/UltraBoard.$SYSTEM::EXT?action=Login&refer=TopicCommands&BID=".$UB::QUERY{'BID'}."&TID=".$UB::QUERY{'TID'}."\n\n";
}

###############################################################################
1; # end of UB_DoMoveTopic.pl file
###############################################################################