###############################################################################
# UB_Email.pl                                                                 #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub Email {
  my ($ERROR) = @_;

  &HTML::Error (CODE => "FUNCTION_DISABLED") if ((!$SYSTEM::SENDMAIL) || (!$GENERAL::FORWARD));

  (
    my ($Account) = &DB::BinarySelect (
      TABLE   => "Accounts",
      KEY     => $UB::QUERY{'UID'}
    )
  ) || &HTML::Error(CODE => "ACCOUNT_NOT_FOUND");

  $Account = &Standard::UnReturn($Account);

# =========================================================================== #
# Printing Forward Form

  &Standard::Require("UB_Email.src", "$UB::INTERFACES_PATH/$SYSTEM::DEFAULT_THEME/UB_Email.src");

  my %FORM = (
    &Standard::ExtraVariables()
  );

  $FORM{'FORM.YOUR.NICKNAME'}    = $UB::QUERY{'FORM_YOUR_NICKNAME'}    || $UB::MEMBER{'NICKNAME'} || $UB::COOKIES{'NICKNAME'};
  $FORM{'FORM.YOUR.EMAIL'}       = $UB::QUERY{'FORM_YOUR_EMAIL'}       || $UB::MEMBER{'EMAIL'}    || $UB::COOKIES{'EMAIL'}   ;
  $FORM{'FORM.TO.NICKNAME'}      = $Account->{'NICKNAME'};
  $FORM{'FORM.TO.USERNAME'}      = $Account->{'USERNAME'};
  $FORM{'FORM.MEMBER.ID'}        = $UB::QUERY{'UID'};

  $FORM{'FORM.SUBJECT'}     = $UB::QUERY{'FORM_SUBJECT'}     || "";
  $FORM{'FORM.MESSAGE'}     = $UB::QUERY{'FORM_MESSAGE'}     || "";

  $FORM{'ERROR.MESSAGE'}    = ((exists $Email::DYNAMIC{"LANGUAGE.".$ERROR}) ? $Email::DYNAMIC{"LANGUAGE.".$ERROR} : $ERROR);

  &Standard::PrintHTMLHeader();
  print &Email::Parse(\%FORM);
}

###############################################################################
1; # end of UB_Email.pl file
###############################################################################