###############################################################################
# UB_Help.pl                                                                  #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub Help {

  if ($UB::QUERY{'HID'} ne "") {
    if (-e $SYSTEM::THEME_PATH."/$SYSTEM::DEFAULT_THEME/Help/".$UB::QUERY{'HID'}) {
      require $SYSTEM::THEME_PATH."/$SYSTEM::DEFAULT_THEME/Help/".$UB::QUERY{'HID'};

      my %HELP = (
        "HELP.DOCUMENT" => &HELP::Document() || ""
      );

      require "$UB::INTERFACES_PATH/$SYSTEM::DEFAULT_THEME/UB_Help_Document.src";
      print "Content-type: text/html\n\n";
      print &Help_Document::Parse(\%HELP);
    } else {
      &HTML::Error (CODE => "HELP_NOT_FOUND");
    }
  } else {
    require $SYSTEM::THEME_PATH."/$SYSTEM::DEFAULT_THEME/Help/Help.cfg";

    require "$UB::INTERFACES_PATH/$SYSTEM::DEFAULT_THEME/UB_Help.src";
    require "$UB::INTERFACES_PATH/$SYSTEM::DEFAULT_THEME/UB_Help_Headlines.src";

    my %HELP = (&Standard::ExtraVariables());
    for (my $idx = 0; $idx <= $#HELP::DOCUMENTS; $idx++) {
      my %HEADLINE = (
        "HEADLINE.NUMBER" => ($idx + 1),
        "HEADLINE.TITLE"  => $HELP::DOCUMENTS[$idx]->{'TITLE'},
        "HEADLINE.HID"    => $HELP::DOCUMENTS[$idx]->{'FILENAME'}
      );
      $HELP{'HELP.HEADLINES'} .= &Help_Headlines::Parse(\%HEADLINE);
    }

    print "Content-type: text/html\n\n";
    print &Help::Parse(\%HELP);
  }

  return 1;
}

###############################################################################
1; # end of UB_Help.pl file
###############################################################################
